// Code generated by go-swagger; DO NOT EDIT.

package accounts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"git.coopcloud.tech/decentral1se/gtslib/models"
)

// AccountHeaderDeleteReader is a Reader for the AccountHeaderDelete structure.
type AccountHeaderDeleteReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *AccountHeaderDeleteReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewAccountHeaderDeleteOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 400:
		result := NewAccountHeaderDeleteBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 401:
		result := NewAccountHeaderDeleteUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewAccountHeaderDeleteForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 406:
		result := NewAccountHeaderDeleteNotAcceptable()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewAccountHeaderDeleteInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("[DELETE /api/v1/profile/header] accountHeaderDelete", response, response.Code())
	}
}

// NewAccountHeaderDeleteOK creates a AccountHeaderDeleteOK with default headers values
func NewAccountHeaderDeleteOK() *AccountHeaderDeleteOK {
	return &AccountHeaderDeleteOK{}
}

/*
AccountHeaderDeleteOK describes a response with status code 200, with default header values.

The updated account, including profile source information.
*/
type AccountHeaderDeleteOK struct {
	Payload *models.Account
}

// IsSuccess returns true when this account header delete o k response has a 2xx status code
func (o *AccountHeaderDeleteOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this account header delete o k response has a 3xx status code
func (o *AccountHeaderDeleteOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this account header delete o k response has a 4xx status code
func (o *AccountHeaderDeleteOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this account header delete o k response has a 5xx status code
func (o *AccountHeaderDeleteOK) IsServerError() bool {
	return false
}

// IsCode returns true when this account header delete o k response a status code equal to that given
func (o *AccountHeaderDeleteOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the account header delete o k response
func (o *AccountHeaderDeleteOK) Code() int {
	return 200
}

func (o *AccountHeaderDeleteOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /api/v1/profile/header][%d] accountHeaderDeleteOK %s", 200, payload)
}

func (o *AccountHeaderDeleteOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /api/v1/profile/header][%d] accountHeaderDeleteOK %s", 200, payload)
}

func (o *AccountHeaderDeleteOK) GetPayload() *models.Account {
	return o.Payload
}

func (o *AccountHeaderDeleteOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Account)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAccountHeaderDeleteBadRequest creates a AccountHeaderDeleteBadRequest with default headers values
func NewAccountHeaderDeleteBadRequest() *AccountHeaderDeleteBadRequest {
	return &AccountHeaderDeleteBadRequest{}
}

/*
AccountHeaderDeleteBadRequest describes a response with status code 400, with default header values.

bad request
*/
type AccountHeaderDeleteBadRequest struct {
}

// IsSuccess returns true when this account header delete bad request response has a 2xx status code
func (o *AccountHeaderDeleteBadRequest) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this account header delete bad request response has a 3xx status code
func (o *AccountHeaderDeleteBadRequest) IsRedirect() bool {
	return false
}

// IsClientError returns true when this account header delete bad request response has a 4xx status code
func (o *AccountHeaderDeleteBadRequest) IsClientError() bool {
	return true
}

// IsServerError returns true when this account header delete bad request response has a 5xx status code
func (o *AccountHeaderDeleteBadRequest) IsServerError() bool {
	return false
}

// IsCode returns true when this account header delete bad request response a status code equal to that given
func (o *AccountHeaderDeleteBadRequest) IsCode(code int) bool {
	return code == 400
}

// Code gets the status code for the account header delete bad request response
func (o *AccountHeaderDeleteBadRequest) Code() int {
	return 400
}

func (o *AccountHeaderDeleteBadRequest) Error() string {
	return fmt.Sprintf("[DELETE /api/v1/profile/header][%d] accountHeaderDeleteBadRequest", 400)
}

func (o *AccountHeaderDeleteBadRequest) String() string {
	return fmt.Sprintf("[DELETE /api/v1/profile/header][%d] accountHeaderDeleteBadRequest", 400)
}

func (o *AccountHeaderDeleteBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewAccountHeaderDeleteUnauthorized creates a AccountHeaderDeleteUnauthorized with default headers values
func NewAccountHeaderDeleteUnauthorized() *AccountHeaderDeleteUnauthorized {
	return &AccountHeaderDeleteUnauthorized{}
}

/*
AccountHeaderDeleteUnauthorized describes a response with status code 401, with default header values.

unauthorized
*/
type AccountHeaderDeleteUnauthorized struct {
}

// IsSuccess returns true when this account header delete unauthorized response has a 2xx status code
func (o *AccountHeaderDeleteUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this account header delete unauthorized response has a 3xx status code
func (o *AccountHeaderDeleteUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this account header delete unauthorized response has a 4xx status code
func (o *AccountHeaderDeleteUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this account header delete unauthorized response has a 5xx status code
func (o *AccountHeaderDeleteUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this account header delete unauthorized response a status code equal to that given
func (o *AccountHeaderDeleteUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the account header delete unauthorized response
func (o *AccountHeaderDeleteUnauthorized) Code() int {
	return 401
}

func (o *AccountHeaderDeleteUnauthorized) Error() string {
	return fmt.Sprintf("[DELETE /api/v1/profile/header][%d] accountHeaderDeleteUnauthorized", 401)
}

func (o *AccountHeaderDeleteUnauthorized) String() string {
	return fmt.Sprintf("[DELETE /api/v1/profile/header][%d] accountHeaderDeleteUnauthorized", 401)
}

func (o *AccountHeaderDeleteUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewAccountHeaderDeleteForbidden creates a AccountHeaderDeleteForbidden with default headers values
func NewAccountHeaderDeleteForbidden() *AccountHeaderDeleteForbidden {
	return &AccountHeaderDeleteForbidden{}
}

/*
AccountHeaderDeleteForbidden describes a response with status code 403, with default header values.

forbidden
*/
type AccountHeaderDeleteForbidden struct {
}

// IsSuccess returns true when this account header delete forbidden response has a 2xx status code
func (o *AccountHeaderDeleteForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this account header delete forbidden response has a 3xx status code
func (o *AccountHeaderDeleteForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this account header delete forbidden response has a 4xx status code
func (o *AccountHeaderDeleteForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this account header delete forbidden response has a 5xx status code
func (o *AccountHeaderDeleteForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this account header delete forbidden response a status code equal to that given
func (o *AccountHeaderDeleteForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the account header delete forbidden response
func (o *AccountHeaderDeleteForbidden) Code() int {
	return 403
}

func (o *AccountHeaderDeleteForbidden) Error() string {
	return fmt.Sprintf("[DELETE /api/v1/profile/header][%d] accountHeaderDeleteForbidden", 403)
}

func (o *AccountHeaderDeleteForbidden) String() string {
	return fmt.Sprintf("[DELETE /api/v1/profile/header][%d] accountHeaderDeleteForbidden", 403)
}

func (o *AccountHeaderDeleteForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewAccountHeaderDeleteNotAcceptable creates a AccountHeaderDeleteNotAcceptable with default headers values
func NewAccountHeaderDeleteNotAcceptable() *AccountHeaderDeleteNotAcceptable {
	return &AccountHeaderDeleteNotAcceptable{}
}

/*
AccountHeaderDeleteNotAcceptable describes a response with status code 406, with default header values.

not acceptable
*/
type AccountHeaderDeleteNotAcceptable struct {
}

// IsSuccess returns true when this account header delete not acceptable response has a 2xx status code
func (o *AccountHeaderDeleteNotAcceptable) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this account header delete not acceptable response has a 3xx status code
func (o *AccountHeaderDeleteNotAcceptable) IsRedirect() bool {
	return false
}

// IsClientError returns true when this account header delete not acceptable response has a 4xx status code
func (o *AccountHeaderDeleteNotAcceptable) IsClientError() bool {
	return true
}

// IsServerError returns true when this account header delete not acceptable response has a 5xx status code
func (o *AccountHeaderDeleteNotAcceptable) IsServerError() bool {
	return false
}

// IsCode returns true when this account header delete not acceptable response a status code equal to that given
func (o *AccountHeaderDeleteNotAcceptable) IsCode(code int) bool {
	return code == 406
}

// Code gets the status code for the account header delete not acceptable response
func (o *AccountHeaderDeleteNotAcceptable) Code() int {
	return 406
}

func (o *AccountHeaderDeleteNotAcceptable) Error() string {
	return fmt.Sprintf("[DELETE /api/v1/profile/header][%d] accountHeaderDeleteNotAcceptable", 406)
}

func (o *AccountHeaderDeleteNotAcceptable) String() string {
	return fmt.Sprintf("[DELETE /api/v1/profile/header][%d] accountHeaderDeleteNotAcceptable", 406)
}

func (o *AccountHeaderDeleteNotAcceptable) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewAccountHeaderDeleteInternalServerError creates a AccountHeaderDeleteInternalServerError with default headers values
func NewAccountHeaderDeleteInternalServerError() *AccountHeaderDeleteInternalServerError {
	return &AccountHeaderDeleteInternalServerError{}
}

/*
AccountHeaderDeleteInternalServerError describes a response with status code 500, with default header values.

internal server error
*/
type AccountHeaderDeleteInternalServerError struct {
}

// IsSuccess returns true when this account header delete internal server error response has a 2xx status code
func (o *AccountHeaderDeleteInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this account header delete internal server error response has a 3xx status code
func (o *AccountHeaderDeleteInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this account header delete internal server error response has a 4xx status code
func (o *AccountHeaderDeleteInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this account header delete internal server error response has a 5xx status code
func (o *AccountHeaderDeleteInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this account header delete internal server error response a status code equal to that given
func (o *AccountHeaderDeleteInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the account header delete internal server error response
func (o *AccountHeaderDeleteInternalServerError) Code() int {
	return 500
}

func (o *AccountHeaderDeleteInternalServerError) Error() string {
	return fmt.Sprintf("[DELETE /api/v1/profile/header][%d] accountHeaderDeleteInternalServerError", 500)
}

func (o *AccountHeaderDeleteInternalServerError) String() string {
	return fmt.Sprintf("[DELETE /api/v1/profile/header][%d] accountHeaderDeleteInternalServerError", 500)
}

func (o *AccountHeaderDeleteInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}
