// Code generated by go-swagger; DO NOT EDIT.

package accounts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewAccountUnmuteParams creates a new AccountUnmuteParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAccountUnmuteParams() *AccountUnmuteParams {
	return &AccountUnmuteParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAccountUnmuteParamsWithTimeout creates a new AccountUnmuteParams object
// with the ability to set a timeout on a request.
func NewAccountUnmuteParamsWithTimeout(timeout time.Duration) *AccountUnmuteParams {
	return &AccountUnmuteParams{
		timeout: timeout,
	}
}

// NewAccountUnmuteParamsWithContext creates a new AccountUnmuteParams object
// with the ability to set a context for a request.
func NewAccountUnmuteParamsWithContext(ctx context.Context) *AccountUnmuteParams {
	return &AccountUnmuteParams{
		Context: ctx,
	}
}

// NewAccountUnmuteParamsWithHTTPClient creates a new AccountUnmuteParams object
// with the ability to set a custom HTTPClient for a request.
func NewAccountUnmuteParamsWithHTTPClient(client *http.Client) *AccountUnmuteParams {
	return &AccountUnmuteParams{
		HTTPClient: client,
	}
}

/*
AccountUnmuteParams contains all the parameters to send to the API endpoint

	for the account unmute operation.

	Typically these are written to a http.Request.
*/
type AccountUnmuteParams struct {

	/* ID.

	   The ID of the account to unmute.
	*/
	ID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the account unmute params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AccountUnmuteParams) WithDefaults() *AccountUnmuteParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the account unmute params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AccountUnmuteParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the account unmute params
func (o *AccountUnmuteParams) WithTimeout(timeout time.Duration) *AccountUnmuteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the account unmute params
func (o *AccountUnmuteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the account unmute params
func (o *AccountUnmuteParams) WithContext(ctx context.Context) *AccountUnmuteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the account unmute params
func (o *AccountUnmuteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the account unmute params
func (o *AccountUnmuteParams) WithHTTPClient(client *http.Client) *AccountUnmuteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the account unmute params
func (o *AccountUnmuteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the account unmute params
func (o *AccountUnmuteParams) WithID(id string) *AccountUnmuteParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the account unmute params
func (o *AccountUnmuteParams) SetID(id string) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *AccountUnmuteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
