// Code generated by go-swagger; DO NOT EDIT.

package admin

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewRuleUpdateParams creates a new RuleUpdateParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRuleUpdateParams() *RuleUpdateParams {
	return &RuleUpdateParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRuleUpdateParamsWithTimeout creates a new RuleUpdateParams object
// with the ability to set a timeout on a request.
func NewRuleUpdateParamsWithTimeout(timeout time.Duration) *RuleUpdateParams {
	return &RuleUpdateParams{
		timeout: timeout,
	}
}

// NewRuleUpdateParamsWithContext creates a new RuleUpdateParams object
// with the ability to set a context for a request.
func NewRuleUpdateParamsWithContext(ctx context.Context) *RuleUpdateParams {
	return &RuleUpdateParams{
		Context: ctx,
	}
}

// NewRuleUpdateParamsWithHTTPClient creates a new RuleUpdateParams object
// with the ability to set a custom HTTPClient for a request.
func NewRuleUpdateParamsWithHTTPClient(client *http.Client) *RuleUpdateParams {
	return &RuleUpdateParams{
		HTTPClient: client,
	}
}

/*
RuleUpdateParams contains all the parameters to send to the API endpoint

	for the rule update operation.

	Typically these are written to a http.Request.
*/
type RuleUpdateParams struct {

	/* ID.

	   The id of the rule to update.
	*/
	ID string

	/* Text.

	   Text body for the updated instance rule, plaintext.
	*/
	Text string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the rule update params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RuleUpdateParams) WithDefaults() *RuleUpdateParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the rule update params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RuleUpdateParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the rule update params
func (o *RuleUpdateParams) WithTimeout(timeout time.Duration) *RuleUpdateParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the rule update params
func (o *RuleUpdateParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the rule update params
func (o *RuleUpdateParams) WithContext(ctx context.Context) *RuleUpdateParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the rule update params
func (o *RuleUpdateParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the rule update params
func (o *RuleUpdateParams) WithHTTPClient(client *http.Client) *RuleUpdateParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the rule update params
func (o *RuleUpdateParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the rule update params
func (o *RuleUpdateParams) WithID(id string) *RuleUpdateParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the rule update params
func (o *RuleUpdateParams) SetID(id string) {
	o.ID = id
}

// WithText adds the text to the rule update params
func (o *RuleUpdateParams) WithText(text string) *RuleUpdateParams {
	o.SetText(text)
	return o
}

// SetText adds the text to the rule update params
func (o *RuleUpdateParams) SetText(text string) {
	o.Text = text
}

// WriteToRequest writes these params to a swagger request
func (o *RuleUpdateParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	// form param text
	frText := o.Text
	fText := frText
	if fText != "" {
		if err := r.SetFormParam("text", fText); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
