// Code generated by go-swagger; DO NOT EDIT.

package conversations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewConversationReadParams creates a new ConversationReadParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewConversationReadParams() *ConversationReadParams {
	return &ConversationReadParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewConversationReadParamsWithTimeout creates a new ConversationReadParams object
// with the ability to set a timeout on a request.
func NewConversationReadParamsWithTimeout(timeout time.Duration) *ConversationReadParams {
	return &ConversationReadParams{
		timeout: timeout,
	}
}

// NewConversationReadParamsWithContext creates a new ConversationReadParams object
// with the ability to set a context for a request.
func NewConversationReadParamsWithContext(ctx context.Context) *ConversationReadParams {
	return &ConversationReadParams{
		Context: ctx,
	}
}

// NewConversationReadParamsWithHTTPClient creates a new ConversationReadParams object
// with the ability to set a custom HTTPClient for a request.
func NewConversationReadParamsWithHTTPClient(client *http.Client) *ConversationReadParams {
	return &ConversationReadParams{
		HTTPClient: client,
	}
}

/*
ConversationReadParams contains all the parameters to send to the API endpoint

	for the conversation read operation.

	Typically these are written to a http.Request.
*/
type ConversationReadParams struct {

	/* ID.

	   ID of the conversation.
	*/
	ID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the conversation read params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ConversationReadParams) WithDefaults() *ConversationReadParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the conversation read params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ConversationReadParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the conversation read params
func (o *ConversationReadParams) WithTimeout(timeout time.Duration) *ConversationReadParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the conversation read params
func (o *ConversationReadParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the conversation read params
func (o *ConversationReadParams) WithContext(ctx context.Context) *ConversationReadParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the conversation read params
func (o *ConversationReadParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the conversation read params
func (o *ConversationReadParams) WithHTTPClient(client *http.Client) *ConversationReadParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the conversation read params
func (o *ConversationReadParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the conversation read params
func (o *ConversationReadParams) WithID(id string) *ConversationReadParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the conversation read params
func (o *ConversationReadParams) SetID(id string) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *ConversationReadParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
