// Code generated by go-swagger; DO NOT EDIT.

package follow_requests

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewAuthorizeFollowRequestParams creates a new AuthorizeFollowRequestParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAuthorizeFollowRequestParams() *AuthorizeFollowRequestParams {
	return &AuthorizeFollowRequestParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAuthorizeFollowRequestParamsWithTimeout creates a new AuthorizeFollowRequestParams object
// with the ability to set a timeout on a request.
func NewAuthorizeFollowRequestParamsWithTimeout(timeout time.Duration) *AuthorizeFollowRequestParams {
	return &AuthorizeFollowRequestParams{
		timeout: timeout,
	}
}

// NewAuthorizeFollowRequestParamsWithContext creates a new AuthorizeFollowRequestParams object
// with the ability to set a context for a request.
func NewAuthorizeFollowRequestParamsWithContext(ctx context.Context) *AuthorizeFollowRequestParams {
	return &AuthorizeFollowRequestParams{
		Context: ctx,
	}
}

// NewAuthorizeFollowRequestParamsWithHTTPClient creates a new AuthorizeFollowRequestParams object
// with the ability to set a custom HTTPClient for a request.
func NewAuthorizeFollowRequestParamsWithHTTPClient(client *http.Client) *AuthorizeFollowRequestParams {
	return &AuthorizeFollowRequestParams{
		HTTPClient: client,
	}
}

/*
AuthorizeFollowRequestParams contains all the parameters to send to the API endpoint

	for the authorize follow request operation.

	Typically these are written to a http.Request.
*/
type AuthorizeFollowRequestParams struct {

	/* AccountID.

	   ID of the account requesting to follow you.
	*/
	AccountID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the authorize follow request params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AuthorizeFollowRequestParams) WithDefaults() *AuthorizeFollowRequestParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the authorize follow request params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AuthorizeFollowRequestParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the authorize follow request params
func (o *AuthorizeFollowRequestParams) WithTimeout(timeout time.Duration) *AuthorizeFollowRequestParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the authorize follow request params
func (o *AuthorizeFollowRequestParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the authorize follow request params
func (o *AuthorizeFollowRequestParams) WithContext(ctx context.Context) *AuthorizeFollowRequestParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the authorize follow request params
func (o *AuthorizeFollowRequestParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the authorize follow request params
func (o *AuthorizeFollowRequestParams) WithHTTPClient(client *http.Client) *AuthorizeFollowRequestParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the authorize follow request params
func (o *AuthorizeFollowRequestParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAccountID adds the accountID to the authorize follow request params
func (o *AuthorizeFollowRequestParams) WithAccountID(accountID string) *AuthorizeFollowRequestParams {
	o.SetAccountID(accountID)
	return o
}

// SetAccountID adds the accountId to the authorize follow request params
func (o *AuthorizeFollowRequestParams) SetAccountID(accountID string) {
	o.AccountID = accountID
}

// WriteToRequest writes these params to a swagger request
func (o *AuthorizeFollowRequestParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param account_id
	if err := r.SetPathParam("account_id", o.AccountID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
