// Code generated by go-swagger; DO NOT EDIT.

package follow_requests

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewRejectFollowRequestParams creates a new RejectFollowRequestParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRejectFollowRequestParams() *RejectFollowRequestParams {
	return &RejectFollowRequestParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRejectFollowRequestParamsWithTimeout creates a new RejectFollowRequestParams object
// with the ability to set a timeout on a request.
func NewRejectFollowRequestParamsWithTimeout(timeout time.Duration) *RejectFollowRequestParams {
	return &RejectFollowRequestParams{
		timeout: timeout,
	}
}

// NewRejectFollowRequestParamsWithContext creates a new RejectFollowRequestParams object
// with the ability to set a context for a request.
func NewRejectFollowRequestParamsWithContext(ctx context.Context) *RejectFollowRequestParams {
	return &RejectFollowRequestParams{
		Context: ctx,
	}
}

// NewRejectFollowRequestParamsWithHTTPClient creates a new RejectFollowRequestParams object
// with the ability to set a custom HTTPClient for a request.
func NewRejectFollowRequestParamsWithHTTPClient(client *http.Client) *RejectFollowRequestParams {
	return &RejectFollowRequestParams{
		HTTPClient: client,
	}
}

/*
RejectFollowRequestParams contains all the parameters to send to the API endpoint

	for the reject follow request operation.

	Typically these are written to a http.Request.
*/
type RejectFollowRequestParams struct {

	/* AccountID.

	   ID of the account requesting to follow you.
	*/
	AccountID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the reject follow request params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RejectFollowRequestParams) WithDefaults() *RejectFollowRequestParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the reject follow request params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RejectFollowRequestParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the reject follow request params
func (o *RejectFollowRequestParams) WithTimeout(timeout time.Duration) *RejectFollowRequestParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the reject follow request params
func (o *RejectFollowRequestParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the reject follow request params
func (o *RejectFollowRequestParams) WithContext(ctx context.Context) *RejectFollowRequestParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the reject follow request params
func (o *RejectFollowRequestParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the reject follow request params
func (o *RejectFollowRequestParams) WithHTTPClient(client *http.Client) *RejectFollowRequestParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the reject follow request params
func (o *RejectFollowRequestParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAccountID adds the accountID to the reject follow request params
func (o *RejectFollowRequestParams) WithAccountID(accountID string) *RejectFollowRequestParams {
	o.SetAccountID(accountID)
	return o
}

// SetAccountID adds the accountId to the reject follow request params
func (o *RejectFollowRequestParams) SetAccountID(accountID string) {
	o.AccountID = accountID
}

// WriteToRequest writes these params to a swagger request
func (o *RejectFollowRequestParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param account_id
	if err := r.SetPathParam("account_id", o.AccountID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
