// Code generated by go-swagger; DO NOT EDIT.

package health

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewReadyHeadParams creates a new ReadyHeadParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewReadyHeadParams() *ReadyHeadParams {
	return &ReadyHeadParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewReadyHeadParamsWithTimeout creates a new ReadyHeadParams object
// with the ability to set a timeout on a request.
func NewReadyHeadParamsWithTimeout(timeout time.Duration) *ReadyHeadParams {
	return &ReadyHeadParams{
		timeout: timeout,
	}
}

// NewReadyHeadParamsWithContext creates a new ReadyHeadParams object
// with the ability to set a context for a request.
func NewReadyHeadParamsWithContext(ctx context.Context) *ReadyHeadParams {
	return &ReadyHeadParams{
		Context: ctx,
	}
}

// NewReadyHeadParamsWithHTTPClient creates a new ReadyHeadParams object
// with the ability to set a custom HTTPClient for a request.
func NewReadyHeadParamsWithHTTPClient(client *http.Client) *ReadyHeadParams {
	return &ReadyHeadParams{
		HTTPClient: client,
	}
}

/*
ReadyHeadParams contains all the parameters to send to the API endpoint

	for the ready head operation.

	Typically these are written to a http.Request.
*/
type ReadyHeadParams struct {
	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the ready head params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ReadyHeadParams) WithDefaults() *ReadyHeadParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the ready head params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ReadyHeadParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the ready head params
func (o *ReadyHeadParams) WithTimeout(timeout time.Duration) *ReadyHeadParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the ready head params
func (o *ReadyHeadParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the ready head params
func (o *ReadyHeadParams) WithContext(ctx context.Context) *ReadyHeadParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the ready head params
func (o *ReadyHeadParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the ready head params
func (o *ReadyHeadParams) WithHTTPClient(client *http.Client) *ReadyHeadParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the ready head params
func (o *ReadyHeadParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WriteToRequest writes these params to a swagger request
func (o *ReadyHeadParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
