// Code generated by go-swagger; DO NOT EDIT.

package interaction_policies

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewPoliciesDefaultsUpdateParams creates a new PoliciesDefaultsUpdateParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPoliciesDefaultsUpdateParams() *PoliciesDefaultsUpdateParams {
	return &PoliciesDefaultsUpdateParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPoliciesDefaultsUpdateParamsWithTimeout creates a new PoliciesDefaultsUpdateParams object
// with the ability to set a timeout on a request.
func NewPoliciesDefaultsUpdateParamsWithTimeout(timeout time.Duration) *PoliciesDefaultsUpdateParams {
	return &PoliciesDefaultsUpdateParams{
		timeout: timeout,
	}
}

// NewPoliciesDefaultsUpdateParamsWithContext creates a new PoliciesDefaultsUpdateParams object
// with the ability to set a context for a request.
func NewPoliciesDefaultsUpdateParamsWithContext(ctx context.Context) *PoliciesDefaultsUpdateParams {
	return &PoliciesDefaultsUpdateParams{
		Context: ctx,
	}
}

// NewPoliciesDefaultsUpdateParamsWithHTTPClient creates a new PoliciesDefaultsUpdateParams object
// with the ability to set a custom HTTPClient for a request.
func NewPoliciesDefaultsUpdateParamsWithHTTPClient(client *http.Client) *PoliciesDefaultsUpdateParams {
	return &PoliciesDefaultsUpdateParams{
		HTTPClient: client,
	}
}

/*
PoliciesDefaultsUpdateParams contains all the parameters to send to the API endpoint

	for the policies defaults update operation.

	Typically these are written to a http.Request.
*/
type PoliciesDefaultsUpdateParams struct {

	/* DirectCanFavouriteAlways0.

	   Nth entry for direct.can_favourite.always.
	*/
	DirectCanFavouriteAlways0 *string

	/* DirectCanFavouriteWithApproval0.

	   Nth entry for direct.can_favourite.with_approval.
	*/
	DirectCanFavouriteWithApproval0 *string

	/* DirectCanReblogAlways0.

	   Nth entry for direct.can_reblog.always.
	*/
	DirectCanReblogAlways0 *string

	/* DirectCanReblogWithApproval0.

	   Nth entry for direct.can_reblog.with_approval.
	*/
	DirectCanReblogWithApproval0 *string

	/* DirectCanReplyAlways0.

	   Nth entry for direct.can_reply.always.
	*/
	DirectCanReplyAlways0 *string

	/* DirectCanReplyWithApproval0.

	   Nth entry for direct.can_reply.with_approval.
	*/
	DirectCanReplyWithApproval0 *string

	/* PrivateCanFavouriteAlways0.

	   Nth entry for private.can_favourite.always.
	*/
	PrivateCanFavouriteAlways0 *string

	/* PrivateCanFavouriteWithApproval0.

	   Nth entry for private.can_favourite.with_approval.
	*/
	PrivateCanFavouriteWithApproval0 *string

	/* PrivateCanReblogAlways0.

	   Nth entry for private.can_reblog.always.
	*/
	PrivateCanReblogAlways0 *string

	/* PrivateCanReblogWithApproval0.

	   Nth entry for private.can_reblog.with_approval.
	*/
	PrivateCanReblogWithApproval0 *string

	/* PrivateCanReplyAlways0.

	   Nth entry for private.can_reply.always.
	*/
	PrivateCanReplyAlways0 *string

	/* PrivateCanReplyWithApproval0.

	   Nth entry for private.can_reply.with_approval.
	*/
	PrivateCanReplyWithApproval0 *string

	/* PublicCanFavouriteAlways0.

	   Nth entry for public.can_favourite.always.
	*/
	PublicCanFavouriteAlways0 *string

	/* PublicCanFavouriteWithApproval0.

	   Nth entry for public.can_favourite.with_approval.
	*/
	PublicCanFavouriteWithApproval0 *string

	/* PublicCanReblogAlways0.

	   Nth entry for public.can_reblog.always.
	*/
	PublicCanReblogAlways0 *string

	/* PublicCanReblogWithApproval0.

	   Nth entry for public.can_reblog.with_approval.
	*/
	PublicCanReblogWithApproval0 *string

	/* PublicCanReplyAlways0.

	   Nth entry for public.can_reply.always.
	*/
	PublicCanReplyAlways0 *string

	/* PublicCanReplyWithApproval0.

	   Nth entry for public.can_reply.with_approval.
	*/
	PublicCanReplyWithApproval0 *string

	/* UnlistedCanFavouriteAlways0.

	   Nth entry for unlisted.can_favourite.always.
	*/
	UnlistedCanFavouriteAlways0 *string

	/* UnlistedCanFavouriteWithApproval0.

	   Nth entry for unlisted.can_favourite.with_approval.
	*/
	UnlistedCanFavouriteWithApproval0 *string

	/* UnlistedCanReblogAlways0.

	   Nth entry for unlisted.can_reblog.always.
	*/
	UnlistedCanReblogAlways0 *string

	/* UnlistedCanReblogWithApproval0.

	   Nth entry for unlisted.can_reblog.with_approval.
	*/
	UnlistedCanReblogWithApproval0 *string

	/* UnlistedCanReplyAlways0.

	   Nth entry for unlisted.can_reply.always.
	*/
	UnlistedCanReplyAlways0 *string

	/* UnlistedCanReplyWithApproval0.

	   Nth entry for unlisted.can_reply.with_approval.
	*/
	UnlistedCanReplyWithApproval0 *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the policies defaults update params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PoliciesDefaultsUpdateParams) WithDefaults() *PoliciesDefaultsUpdateParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the policies defaults update params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PoliciesDefaultsUpdateParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) WithTimeout(timeout time.Duration) *PoliciesDefaultsUpdateParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) WithContext(ctx context.Context) *PoliciesDefaultsUpdateParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) WithHTTPClient(client *http.Client) *PoliciesDefaultsUpdateParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithDirectCanFavouriteAlways0 adds the directCanFavouriteAlways0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) WithDirectCanFavouriteAlways0(directCanFavouriteAlways0 *string) *PoliciesDefaultsUpdateParams {
	o.SetDirectCanFavouriteAlways0(directCanFavouriteAlways0)
	return o
}

// SetDirectCanFavouriteAlways0 adds the directCanFavouriteAlways0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) SetDirectCanFavouriteAlways0(directCanFavouriteAlways0 *string) {
	o.DirectCanFavouriteAlways0 = directCanFavouriteAlways0
}

// WithDirectCanFavouriteWithApproval0 adds the directCanFavouriteWithApproval0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) WithDirectCanFavouriteWithApproval0(directCanFavouriteWithApproval0 *string) *PoliciesDefaultsUpdateParams {
	o.SetDirectCanFavouriteWithApproval0(directCanFavouriteWithApproval0)
	return o
}

// SetDirectCanFavouriteWithApproval0 adds the directCanFavouriteWithApproval0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) SetDirectCanFavouriteWithApproval0(directCanFavouriteWithApproval0 *string) {
	o.DirectCanFavouriteWithApproval0 = directCanFavouriteWithApproval0
}

// WithDirectCanReblogAlways0 adds the directCanReblogAlways0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) WithDirectCanReblogAlways0(directCanReblogAlways0 *string) *PoliciesDefaultsUpdateParams {
	o.SetDirectCanReblogAlways0(directCanReblogAlways0)
	return o
}

// SetDirectCanReblogAlways0 adds the directCanReblogAlways0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) SetDirectCanReblogAlways0(directCanReblogAlways0 *string) {
	o.DirectCanReblogAlways0 = directCanReblogAlways0
}

// WithDirectCanReblogWithApproval0 adds the directCanReblogWithApproval0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) WithDirectCanReblogWithApproval0(directCanReblogWithApproval0 *string) *PoliciesDefaultsUpdateParams {
	o.SetDirectCanReblogWithApproval0(directCanReblogWithApproval0)
	return o
}

// SetDirectCanReblogWithApproval0 adds the directCanReblogWithApproval0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) SetDirectCanReblogWithApproval0(directCanReblogWithApproval0 *string) {
	o.DirectCanReblogWithApproval0 = directCanReblogWithApproval0
}

// WithDirectCanReplyAlways0 adds the directCanReplyAlways0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) WithDirectCanReplyAlways0(directCanReplyAlways0 *string) *PoliciesDefaultsUpdateParams {
	o.SetDirectCanReplyAlways0(directCanReplyAlways0)
	return o
}

// SetDirectCanReplyAlways0 adds the directCanReplyAlways0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) SetDirectCanReplyAlways0(directCanReplyAlways0 *string) {
	o.DirectCanReplyAlways0 = directCanReplyAlways0
}

// WithDirectCanReplyWithApproval0 adds the directCanReplyWithApproval0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) WithDirectCanReplyWithApproval0(directCanReplyWithApproval0 *string) *PoliciesDefaultsUpdateParams {
	o.SetDirectCanReplyWithApproval0(directCanReplyWithApproval0)
	return o
}

// SetDirectCanReplyWithApproval0 adds the directCanReplyWithApproval0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) SetDirectCanReplyWithApproval0(directCanReplyWithApproval0 *string) {
	o.DirectCanReplyWithApproval0 = directCanReplyWithApproval0
}

// WithPrivateCanFavouriteAlways0 adds the privateCanFavouriteAlways0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) WithPrivateCanFavouriteAlways0(privateCanFavouriteAlways0 *string) *PoliciesDefaultsUpdateParams {
	o.SetPrivateCanFavouriteAlways0(privateCanFavouriteAlways0)
	return o
}

// SetPrivateCanFavouriteAlways0 adds the privateCanFavouriteAlways0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) SetPrivateCanFavouriteAlways0(privateCanFavouriteAlways0 *string) {
	o.PrivateCanFavouriteAlways0 = privateCanFavouriteAlways0
}

// WithPrivateCanFavouriteWithApproval0 adds the privateCanFavouriteWithApproval0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) WithPrivateCanFavouriteWithApproval0(privateCanFavouriteWithApproval0 *string) *PoliciesDefaultsUpdateParams {
	o.SetPrivateCanFavouriteWithApproval0(privateCanFavouriteWithApproval0)
	return o
}

// SetPrivateCanFavouriteWithApproval0 adds the privateCanFavouriteWithApproval0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) SetPrivateCanFavouriteWithApproval0(privateCanFavouriteWithApproval0 *string) {
	o.PrivateCanFavouriteWithApproval0 = privateCanFavouriteWithApproval0
}

// WithPrivateCanReblogAlways0 adds the privateCanReblogAlways0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) WithPrivateCanReblogAlways0(privateCanReblogAlways0 *string) *PoliciesDefaultsUpdateParams {
	o.SetPrivateCanReblogAlways0(privateCanReblogAlways0)
	return o
}

// SetPrivateCanReblogAlways0 adds the privateCanReblogAlways0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) SetPrivateCanReblogAlways0(privateCanReblogAlways0 *string) {
	o.PrivateCanReblogAlways0 = privateCanReblogAlways0
}

// WithPrivateCanReblogWithApproval0 adds the privateCanReblogWithApproval0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) WithPrivateCanReblogWithApproval0(privateCanReblogWithApproval0 *string) *PoliciesDefaultsUpdateParams {
	o.SetPrivateCanReblogWithApproval0(privateCanReblogWithApproval0)
	return o
}

// SetPrivateCanReblogWithApproval0 adds the privateCanReblogWithApproval0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) SetPrivateCanReblogWithApproval0(privateCanReblogWithApproval0 *string) {
	o.PrivateCanReblogWithApproval0 = privateCanReblogWithApproval0
}

// WithPrivateCanReplyAlways0 adds the privateCanReplyAlways0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) WithPrivateCanReplyAlways0(privateCanReplyAlways0 *string) *PoliciesDefaultsUpdateParams {
	o.SetPrivateCanReplyAlways0(privateCanReplyAlways0)
	return o
}

// SetPrivateCanReplyAlways0 adds the privateCanReplyAlways0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) SetPrivateCanReplyAlways0(privateCanReplyAlways0 *string) {
	o.PrivateCanReplyAlways0 = privateCanReplyAlways0
}

// WithPrivateCanReplyWithApproval0 adds the privateCanReplyWithApproval0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) WithPrivateCanReplyWithApproval0(privateCanReplyWithApproval0 *string) *PoliciesDefaultsUpdateParams {
	o.SetPrivateCanReplyWithApproval0(privateCanReplyWithApproval0)
	return o
}

// SetPrivateCanReplyWithApproval0 adds the privateCanReplyWithApproval0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) SetPrivateCanReplyWithApproval0(privateCanReplyWithApproval0 *string) {
	o.PrivateCanReplyWithApproval0 = privateCanReplyWithApproval0
}

// WithPublicCanFavouriteAlways0 adds the publicCanFavouriteAlways0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) WithPublicCanFavouriteAlways0(publicCanFavouriteAlways0 *string) *PoliciesDefaultsUpdateParams {
	o.SetPublicCanFavouriteAlways0(publicCanFavouriteAlways0)
	return o
}

// SetPublicCanFavouriteAlways0 adds the publicCanFavouriteAlways0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) SetPublicCanFavouriteAlways0(publicCanFavouriteAlways0 *string) {
	o.PublicCanFavouriteAlways0 = publicCanFavouriteAlways0
}

// WithPublicCanFavouriteWithApproval0 adds the publicCanFavouriteWithApproval0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) WithPublicCanFavouriteWithApproval0(publicCanFavouriteWithApproval0 *string) *PoliciesDefaultsUpdateParams {
	o.SetPublicCanFavouriteWithApproval0(publicCanFavouriteWithApproval0)
	return o
}

// SetPublicCanFavouriteWithApproval0 adds the publicCanFavouriteWithApproval0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) SetPublicCanFavouriteWithApproval0(publicCanFavouriteWithApproval0 *string) {
	o.PublicCanFavouriteWithApproval0 = publicCanFavouriteWithApproval0
}

// WithPublicCanReblogAlways0 adds the publicCanReblogAlways0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) WithPublicCanReblogAlways0(publicCanReblogAlways0 *string) *PoliciesDefaultsUpdateParams {
	o.SetPublicCanReblogAlways0(publicCanReblogAlways0)
	return o
}

// SetPublicCanReblogAlways0 adds the publicCanReblogAlways0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) SetPublicCanReblogAlways0(publicCanReblogAlways0 *string) {
	o.PublicCanReblogAlways0 = publicCanReblogAlways0
}

// WithPublicCanReblogWithApproval0 adds the publicCanReblogWithApproval0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) WithPublicCanReblogWithApproval0(publicCanReblogWithApproval0 *string) *PoliciesDefaultsUpdateParams {
	o.SetPublicCanReblogWithApproval0(publicCanReblogWithApproval0)
	return o
}

// SetPublicCanReblogWithApproval0 adds the publicCanReblogWithApproval0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) SetPublicCanReblogWithApproval0(publicCanReblogWithApproval0 *string) {
	o.PublicCanReblogWithApproval0 = publicCanReblogWithApproval0
}

// WithPublicCanReplyAlways0 adds the publicCanReplyAlways0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) WithPublicCanReplyAlways0(publicCanReplyAlways0 *string) *PoliciesDefaultsUpdateParams {
	o.SetPublicCanReplyAlways0(publicCanReplyAlways0)
	return o
}

// SetPublicCanReplyAlways0 adds the publicCanReplyAlways0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) SetPublicCanReplyAlways0(publicCanReplyAlways0 *string) {
	o.PublicCanReplyAlways0 = publicCanReplyAlways0
}

// WithPublicCanReplyWithApproval0 adds the publicCanReplyWithApproval0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) WithPublicCanReplyWithApproval0(publicCanReplyWithApproval0 *string) *PoliciesDefaultsUpdateParams {
	o.SetPublicCanReplyWithApproval0(publicCanReplyWithApproval0)
	return o
}

// SetPublicCanReplyWithApproval0 adds the publicCanReplyWithApproval0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) SetPublicCanReplyWithApproval0(publicCanReplyWithApproval0 *string) {
	o.PublicCanReplyWithApproval0 = publicCanReplyWithApproval0
}

// WithUnlistedCanFavouriteAlways0 adds the unlistedCanFavouriteAlways0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) WithUnlistedCanFavouriteAlways0(unlistedCanFavouriteAlways0 *string) *PoliciesDefaultsUpdateParams {
	o.SetUnlistedCanFavouriteAlways0(unlistedCanFavouriteAlways0)
	return o
}

// SetUnlistedCanFavouriteAlways0 adds the unlistedCanFavouriteAlways0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) SetUnlistedCanFavouriteAlways0(unlistedCanFavouriteAlways0 *string) {
	o.UnlistedCanFavouriteAlways0 = unlistedCanFavouriteAlways0
}

// WithUnlistedCanFavouriteWithApproval0 adds the unlistedCanFavouriteWithApproval0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) WithUnlistedCanFavouriteWithApproval0(unlistedCanFavouriteWithApproval0 *string) *PoliciesDefaultsUpdateParams {
	o.SetUnlistedCanFavouriteWithApproval0(unlistedCanFavouriteWithApproval0)
	return o
}

// SetUnlistedCanFavouriteWithApproval0 adds the unlistedCanFavouriteWithApproval0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) SetUnlistedCanFavouriteWithApproval0(unlistedCanFavouriteWithApproval0 *string) {
	o.UnlistedCanFavouriteWithApproval0 = unlistedCanFavouriteWithApproval0
}

// WithUnlistedCanReblogAlways0 adds the unlistedCanReblogAlways0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) WithUnlistedCanReblogAlways0(unlistedCanReblogAlways0 *string) *PoliciesDefaultsUpdateParams {
	o.SetUnlistedCanReblogAlways0(unlistedCanReblogAlways0)
	return o
}

// SetUnlistedCanReblogAlways0 adds the unlistedCanReblogAlways0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) SetUnlistedCanReblogAlways0(unlistedCanReblogAlways0 *string) {
	o.UnlistedCanReblogAlways0 = unlistedCanReblogAlways0
}

// WithUnlistedCanReblogWithApproval0 adds the unlistedCanReblogWithApproval0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) WithUnlistedCanReblogWithApproval0(unlistedCanReblogWithApproval0 *string) *PoliciesDefaultsUpdateParams {
	o.SetUnlistedCanReblogWithApproval0(unlistedCanReblogWithApproval0)
	return o
}

// SetUnlistedCanReblogWithApproval0 adds the unlistedCanReblogWithApproval0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) SetUnlistedCanReblogWithApproval0(unlistedCanReblogWithApproval0 *string) {
	o.UnlistedCanReblogWithApproval0 = unlistedCanReblogWithApproval0
}

// WithUnlistedCanReplyAlways0 adds the unlistedCanReplyAlways0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) WithUnlistedCanReplyAlways0(unlistedCanReplyAlways0 *string) *PoliciesDefaultsUpdateParams {
	o.SetUnlistedCanReplyAlways0(unlistedCanReplyAlways0)
	return o
}

// SetUnlistedCanReplyAlways0 adds the unlistedCanReplyAlways0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) SetUnlistedCanReplyAlways0(unlistedCanReplyAlways0 *string) {
	o.UnlistedCanReplyAlways0 = unlistedCanReplyAlways0
}

// WithUnlistedCanReplyWithApproval0 adds the unlistedCanReplyWithApproval0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) WithUnlistedCanReplyWithApproval0(unlistedCanReplyWithApproval0 *string) *PoliciesDefaultsUpdateParams {
	o.SetUnlistedCanReplyWithApproval0(unlistedCanReplyWithApproval0)
	return o
}

// SetUnlistedCanReplyWithApproval0 adds the unlistedCanReplyWithApproval0 to the policies defaults update params
func (o *PoliciesDefaultsUpdateParams) SetUnlistedCanReplyWithApproval0(unlistedCanReplyWithApproval0 *string) {
	o.UnlistedCanReplyWithApproval0 = unlistedCanReplyWithApproval0
}

// WriteToRequest writes these params to a swagger request
func (o *PoliciesDefaultsUpdateParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.DirectCanFavouriteAlways0 != nil {

		// form param direct[can_favourite][always][0]
		var frDirectCanFavouriteAlways0 string
		if o.DirectCanFavouriteAlways0 != nil {
			frDirectCanFavouriteAlways0 = *o.DirectCanFavouriteAlways0
		}
		fDirectCanFavouriteAlways0 := frDirectCanFavouriteAlways0
		if fDirectCanFavouriteAlways0 != "" {
			if err := r.SetFormParam("direct[can_favourite][always][0]", fDirectCanFavouriteAlways0); err != nil {
				return err
			}
		}
	}

	if o.DirectCanFavouriteWithApproval0 != nil {

		// form param direct[can_favourite][with_approval][0]
		var frDirectCanFavouriteWithApproval0 string
		if o.DirectCanFavouriteWithApproval0 != nil {
			frDirectCanFavouriteWithApproval0 = *o.DirectCanFavouriteWithApproval0
		}
		fDirectCanFavouriteWithApproval0 := frDirectCanFavouriteWithApproval0
		if fDirectCanFavouriteWithApproval0 != "" {
			if err := r.SetFormParam("direct[can_favourite][with_approval][0]", fDirectCanFavouriteWithApproval0); err != nil {
				return err
			}
		}
	}

	if o.DirectCanReblogAlways0 != nil {

		// form param direct[can_reblog][always][0]
		var frDirectCanReblogAlways0 string
		if o.DirectCanReblogAlways0 != nil {
			frDirectCanReblogAlways0 = *o.DirectCanReblogAlways0
		}
		fDirectCanReblogAlways0 := frDirectCanReblogAlways0
		if fDirectCanReblogAlways0 != "" {
			if err := r.SetFormParam("direct[can_reblog][always][0]", fDirectCanReblogAlways0); err != nil {
				return err
			}
		}
	}

	if o.DirectCanReblogWithApproval0 != nil {

		// form param direct[can_reblog][with_approval][0]
		var frDirectCanReblogWithApproval0 string
		if o.DirectCanReblogWithApproval0 != nil {
			frDirectCanReblogWithApproval0 = *o.DirectCanReblogWithApproval0
		}
		fDirectCanReblogWithApproval0 := frDirectCanReblogWithApproval0
		if fDirectCanReblogWithApproval0 != "" {
			if err := r.SetFormParam("direct[can_reblog][with_approval][0]", fDirectCanReblogWithApproval0); err != nil {
				return err
			}
		}
	}

	if o.DirectCanReplyAlways0 != nil {

		// form param direct[can_reply][always][0]
		var frDirectCanReplyAlways0 string
		if o.DirectCanReplyAlways0 != nil {
			frDirectCanReplyAlways0 = *o.DirectCanReplyAlways0
		}
		fDirectCanReplyAlways0 := frDirectCanReplyAlways0
		if fDirectCanReplyAlways0 != "" {
			if err := r.SetFormParam("direct[can_reply][always][0]", fDirectCanReplyAlways0); err != nil {
				return err
			}
		}
	}

	if o.DirectCanReplyWithApproval0 != nil {

		// form param direct[can_reply][with_approval][0]
		var frDirectCanReplyWithApproval0 string
		if o.DirectCanReplyWithApproval0 != nil {
			frDirectCanReplyWithApproval0 = *o.DirectCanReplyWithApproval0
		}
		fDirectCanReplyWithApproval0 := frDirectCanReplyWithApproval0
		if fDirectCanReplyWithApproval0 != "" {
			if err := r.SetFormParam("direct[can_reply][with_approval][0]", fDirectCanReplyWithApproval0); err != nil {
				return err
			}
		}
	}

	if o.PrivateCanFavouriteAlways0 != nil {

		// form param private[can_favourite][always][0]
		var frPrivateCanFavouriteAlways0 string
		if o.PrivateCanFavouriteAlways0 != nil {
			frPrivateCanFavouriteAlways0 = *o.PrivateCanFavouriteAlways0
		}
		fPrivateCanFavouriteAlways0 := frPrivateCanFavouriteAlways0
		if fPrivateCanFavouriteAlways0 != "" {
			if err := r.SetFormParam("private[can_favourite][always][0]", fPrivateCanFavouriteAlways0); err != nil {
				return err
			}
		}
	}

	if o.PrivateCanFavouriteWithApproval0 != nil {

		// form param private[can_favourite][with_approval][0]
		var frPrivateCanFavouriteWithApproval0 string
		if o.PrivateCanFavouriteWithApproval0 != nil {
			frPrivateCanFavouriteWithApproval0 = *o.PrivateCanFavouriteWithApproval0
		}
		fPrivateCanFavouriteWithApproval0 := frPrivateCanFavouriteWithApproval0
		if fPrivateCanFavouriteWithApproval0 != "" {
			if err := r.SetFormParam("private[can_favourite][with_approval][0]", fPrivateCanFavouriteWithApproval0); err != nil {
				return err
			}
		}
	}

	if o.PrivateCanReblogAlways0 != nil {

		// form param private[can_reblog][always][0]
		var frPrivateCanReblogAlways0 string
		if o.PrivateCanReblogAlways0 != nil {
			frPrivateCanReblogAlways0 = *o.PrivateCanReblogAlways0
		}
		fPrivateCanReblogAlways0 := frPrivateCanReblogAlways0
		if fPrivateCanReblogAlways0 != "" {
			if err := r.SetFormParam("private[can_reblog][always][0]", fPrivateCanReblogAlways0); err != nil {
				return err
			}
		}
	}

	if o.PrivateCanReblogWithApproval0 != nil {

		// form param private[can_reblog][with_approval][0]
		var frPrivateCanReblogWithApproval0 string
		if o.PrivateCanReblogWithApproval0 != nil {
			frPrivateCanReblogWithApproval0 = *o.PrivateCanReblogWithApproval0
		}
		fPrivateCanReblogWithApproval0 := frPrivateCanReblogWithApproval0
		if fPrivateCanReblogWithApproval0 != "" {
			if err := r.SetFormParam("private[can_reblog][with_approval][0]", fPrivateCanReblogWithApproval0); err != nil {
				return err
			}
		}
	}

	if o.PrivateCanReplyAlways0 != nil {

		// form param private[can_reply][always][0]
		var frPrivateCanReplyAlways0 string
		if o.PrivateCanReplyAlways0 != nil {
			frPrivateCanReplyAlways0 = *o.PrivateCanReplyAlways0
		}
		fPrivateCanReplyAlways0 := frPrivateCanReplyAlways0
		if fPrivateCanReplyAlways0 != "" {
			if err := r.SetFormParam("private[can_reply][always][0]", fPrivateCanReplyAlways0); err != nil {
				return err
			}
		}
	}

	if o.PrivateCanReplyWithApproval0 != nil {

		// form param private[can_reply][with_approval][0]
		var frPrivateCanReplyWithApproval0 string
		if o.PrivateCanReplyWithApproval0 != nil {
			frPrivateCanReplyWithApproval0 = *o.PrivateCanReplyWithApproval0
		}
		fPrivateCanReplyWithApproval0 := frPrivateCanReplyWithApproval0
		if fPrivateCanReplyWithApproval0 != "" {
			if err := r.SetFormParam("private[can_reply][with_approval][0]", fPrivateCanReplyWithApproval0); err != nil {
				return err
			}
		}
	}

	if o.PublicCanFavouriteAlways0 != nil {

		// form param public[can_favourite][always][0]
		var frPublicCanFavouriteAlways0 string
		if o.PublicCanFavouriteAlways0 != nil {
			frPublicCanFavouriteAlways0 = *o.PublicCanFavouriteAlways0
		}
		fPublicCanFavouriteAlways0 := frPublicCanFavouriteAlways0
		if fPublicCanFavouriteAlways0 != "" {
			if err := r.SetFormParam("public[can_favourite][always][0]", fPublicCanFavouriteAlways0); err != nil {
				return err
			}
		}
	}

	if o.PublicCanFavouriteWithApproval0 != nil {

		// form param public[can_favourite][with_approval][0]
		var frPublicCanFavouriteWithApproval0 string
		if o.PublicCanFavouriteWithApproval0 != nil {
			frPublicCanFavouriteWithApproval0 = *o.PublicCanFavouriteWithApproval0
		}
		fPublicCanFavouriteWithApproval0 := frPublicCanFavouriteWithApproval0
		if fPublicCanFavouriteWithApproval0 != "" {
			if err := r.SetFormParam("public[can_favourite][with_approval][0]", fPublicCanFavouriteWithApproval0); err != nil {
				return err
			}
		}
	}

	if o.PublicCanReblogAlways0 != nil {

		// form param public[can_reblog][always][0]
		var frPublicCanReblogAlways0 string
		if o.PublicCanReblogAlways0 != nil {
			frPublicCanReblogAlways0 = *o.PublicCanReblogAlways0
		}
		fPublicCanReblogAlways0 := frPublicCanReblogAlways0
		if fPublicCanReblogAlways0 != "" {
			if err := r.SetFormParam("public[can_reblog][always][0]", fPublicCanReblogAlways0); err != nil {
				return err
			}
		}
	}

	if o.PublicCanReblogWithApproval0 != nil {

		// form param public[can_reblog][with_approval][0]
		var frPublicCanReblogWithApproval0 string
		if o.PublicCanReblogWithApproval0 != nil {
			frPublicCanReblogWithApproval0 = *o.PublicCanReblogWithApproval0
		}
		fPublicCanReblogWithApproval0 := frPublicCanReblogWithApproval0
		if fPublicCanReblogWithApproval0 != "" {
			if err := r.SetFormParam("public[can_reblog][with_approval][0]", fPublicCanReblogWithApproval0); err != nil {
				return err
			}
		}
	}

	if o.PublicCanReplyAlways0 != nil {

		// form param public[can_reply][always][0]
		var frPublicCanReplyAlways0 string
		if o.PublicCanReplyAlways0 != nil {
			frPublicCanReplyAlways0 = *o.PublicCanReplyAlways0
		}
		fPublicCanReplyAlways0 := frPublicCanReplyAlways0
		if fPublicCanReplyAlways0 != "" {
			if err := r.SetFormParam("public[can_reply][always][0]", fPublicCanReplyAlways0); err != nil {
				return err
			}
		}
	}

	if o.PublicCanReplyWithApproval0 != nil {

		// form param public[can_reply][with_approval][0]
		var frPublicCanReplyWithApproval0 string
		if o.PublicCanReplyWithApproval0 != nil {
			frPublicCanReplyWithApproval0 = *o.PublicCanReplyWithApproval0
		}
		fPublicCanReplyWithApproval0 := frPublicCanReplyWithApproval0
		if fPublicCanReplyWithApproval0 != "" {
			if err := r.SetFormParam("public[can_reply][with_approval][0]", fPublicCanReplyWithApproval0); err != nil {
				return err
			}
		}
	}

	if o.UnlistedCanFavouriteAlways0 != nil {

		// form param unlisted[can_favourite][always][0]
		var frUnlistedCanFavouriteAlways0 string
		if o.UnlistedCanFavouriteAlways0 != nil {
			frUnlistedCanFavouriteAlways0 = *o.UnlistedCanFavouriteAlways0
		}
		fUnlistedCanFavouriteAlways0 := frUnlistedCanFavouriteAlways0
		if fUnlistedCanFavouriteAlways0 != "" {
			if err := r.SetFormParam("unlisted[can_favourite][always][0]", fUnlistedCanFavouriteAlways0); err != nil {
				return err
			}
		}
	}

	if o.UnlistedCanFavouriteWithApproval0 != nil {

		// form param unlisted[can_favourite][with_approval][0]
		var frUnlistedCanFavouriteWithApproval0 string
		if o.UnlistedCanFavouriteWithApproval0 != nil {
			frUnlistedCanFavouriteWithApproval0 = *o.UnlistedCanFavouriteWithApproval0
		}
		fUnlistedCanFavouriteWithApproval0 := frUnlistedCanFavouriteWithApproval0
		if fUnlistedCanFavouriteWithApproval0 != "" {
			if err := r.SetFormParam("unlisted[can_favourite][with_approval][0]", fUnlistedCanFavouriteWithApproval0); err != nil {
				return err
			}
		}
	}

	if o.UnlistedCanReblogAlways0 != nil {

		// form param unlisted[can_reblog][always][0]
		var frUnlistedCanReblogAlways0 string
		if o.UnlistedCanReblogAlways0 != nil {
			frUnlistedCanReblogAlways0 = *o.UnlistedCanReblogAlways0
		}
		fUnlistedCanReblogAlways0 := frUnlistedCanReblogAlways0
		if fUnlistedCanReblogAlways0 != "" {
			if err := r.SetFormParam("unlisted[can_reblog][always][0]", fUnlistedCanReblogAlways0); err != nil {
				return err
			}
		}
	}

	if o.UnlistedCanReblogWithApproval0 != nil {

		// form param unlisted[can_reblog][with_approval][0]
		var frUnlistedCanReblogWithApproval0 string
		if o.UnlistedCanReblogWithApproval0 != nil {
			frUnlistedCanReblogWithApproval0 = *o.UnlistedCanReblogWithApproval0
		}
		fUnlistedCanReblogWithApproval0 := frUnlistedCanReblogWithApproval0
		if fUnlistedCanReblogWithApproval0 != "" {
			if err := r.SetFormParam("unlisted[can_reblog][with_approval][0]", fUnlistedCanReblogWithApproval0); err != nil {
				return err
			}
		}
	}

	if o.UnlistedCanReplyAlways0 != nil {

		// form param unlisted[can_reply][always][0]
		var frUnlistedCanReplyAlways0 string
		if o.UnlistedCanReplyAlways0 != nil {
			frUnlistedCanReplyAlways0 = *o.UnlistedCanReplyAlways0
		}
		fUnlistedCanReplyAlways0 := frUnlistedCanReplyAlways0
		if fUnlistedCanReplyAlways0 != "" {
			if err := r.SetFormParam("unlisted[can_reply][always][0]", fUnlistedCanReplyAlways0); err != nil {
				return err
			}
		}
	}

	if o.UnlistedCanReplyWithApproval0 != nil {

		// form param unlisted[can_reply][with_approval][0]
		var frUnlistedCanReplyWithApproval0 string
		if o.UnlistedCanReplyWithApproval0 != nil {
			frUnlistedCanReplyWithApproval0 = *o.UnlistedCanReplyWithApproval0
		}
		fUnlistedCanReplyWithApproval0 := frUnlistedCanReplyWithApproval0
		if fUnlistedCanReplyWithApproval0 != "" {
			if err := r.SetFormParam("unlisted[can_reply][with_approval][0]", fUnlistedCanReplyWithApproval0); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
