// Code generated by go-swagger; DO NOT EDIT.

package lists

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewListAccountsParams creates a new ListAccountsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewListAccountsParams() *ListAccountsParams {
	return &ListAccountsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewListAccountsParamsWithTimeout creates a new ListAccountsParams object
// with the ability to set a timeout on a request.
func NewListAccountsParamsWithTimeout(timeout time.Duration) *ListAccountsParams {
	return &ListAccountsParams{
		timeout: timeout,
	}
}

// NewListAccountsParamsWithContext creates a new ListAccountsParams object
// with the ability to set a context for a request.
func NewListAccountsParamsWithContext(ctx context.Context) *ListAccountsParams {
	return &ListAccountsParams{
		Context: ctx,
	}
}

// NewListAccountsParamsWithHTTPClient creates a new ListAccountsParams object
// with the ability to set a custom HTTPClient for a request.
func NewListAccountsParamsWithHTTPClient(client *http.Client) *ListAccountsParams {
	return &ListAccountsParams{
		HTTPClient: client,
	}
}

/*
ListAccountsParams contains all the parameters to send to the API endpoint

	for the list accounts operation.

	Typically these are written to a http.Request.
*/
type ListAccountsParams struct {

	/* ID.

	   ID of the list
	*/
	ID string

	/* Limit.

	   Number of accounts to return. If set to 0 explicitly, all accounts in the list will be returned, and pagination headers will not be used. This is a workaround for Mastodon API peculiarities: https://docs.joinmastodon.org/methods/lists/#query-parameters.

	   Default: 40
	*/
	Limit *int64

	/* MaxID.

	   Return only list entries *OLDER* than the given max ID. The account from the list entry with the specified ID will not be included in the response.
	*/
	MaxID *string

	/* MinID.

	   Return only list entries *IMMEDIATELY NEWER* than the given min ID. The account from the list entry with the specified ID will not be included in the response.
	*/
	MinID *string

	/* SinceID.

	   Return only list entries *NEWER* than the given since ID. The account from the list entry with the specified ID will not be included in the response.
	*/
	SinceID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the list accounts params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ListAccountsParams) WithDefaults() *ListAccountsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the list accounts params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ListAccountsParams) SetDefaults() {
	var (
		limitDefault = int64(40)
	)

	val := ListAccountsParams{
		Limit: &limitDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the list accounts params
func (o *ListAccountsParams) WithTimeout(timeout time.Duration) *ListAccountsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the list accounts params
func (o *ListAccountsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the list accounts params
func (o *ListAccountsParams) WithContext(ctx context.Context) *ListAccountsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the list accounts params
func (o *ListAccountsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the list accounts params
func (o *ListAccountsParams) WithHTTPClient(client *http.Client) *ListAccountsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the list accounts params
func (o *ListAccountsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the list accounts params
func (o *ListAccountsParams) WithID(id string) *ListAccountsParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the list accounts params
func (o *ListAccountsParams) SetID(id string) {
	o.ID = id
}

// WithLimit adds the limit to the list accounts params
func (o *ListAccountsParams) WithLimit(limit *int64) *ListAccountsParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the list accounts params
func (o *ListAccountsParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithMaxID adds the maxID to the list accounts params
func (o *ListAccountsParams) WithMaxID(maxID *string) *ListAccountsParams {
	o.SetMaxID(maxID)
	return o
}

// SetMaxID adds the maxId to the list accounts params
func (o *ListAccountsParams) SetMaxID(maxID *string) {
	o.MaxID = maxID
}

// WithMinID adds the minID to the list accounts params
func (o *ListAccountsParams) WithMinID(minID *string) *ListAccountsParams {
	o.SetMinID(minID)
	return o
}

// SetMinID adds the minId to the list accounts params
func (o *ListAccountsParams) SetMinID(minID *string) {
	o.MinID = minID
}

// WithSinceID adds the sinceID to the list accounts params
func (o *ListAccountsParams) WithSinceID(sinceID *string) *ListAccountsParams {
	o.SetSinceID(sinceID)
	return o
}

// SetSinceID adds the sinceId to the list accounts params
func (o *ListAccountsParams) SetSinceID(sinceID *string) {
	o.SinceID = sinceID
}

// WriteToRequest writes these params to a swagger request
func (o *ListAccountsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.MaxID != nil {

		// query param max_id
		var qrMaxID string

		if o.MaxID != nil {
			qrMaxID = *o.MaxID
		}
		qMaxID := qrMaxID
		if qMaxID != "" {

			if err := r.SetQueryParam("max_id", qMaxID); err != nil {
				return err
			}
		}
	}

	if o.MinID != nil {

		// query param min_id
		var qrMinID string

		if o.MinID != nil {
			qrMinID = *o.MinID
		}
		qMinID := qrMinID
		if qMinID != "" {

			if err := r.SetQueryParam("min_id", qMinID); err != nil {
				return err
			}
		}
	}

	if o.SinceID != nil {

		// query param since_id
		var qrSinceID string

		if o.SinceID != nil {
			qrSinceID = *o.SinceID
		}
		qSinceID := qrSinceID
		if qSinceID != "" {

			if err := r.SetQueryParam("since_id", qSinceID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
