// Code generated by go-swagger; DO NOT EDIT.

package media

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewMediaGetParams creates a new MediaGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewMediaGetParams() *MediaGetParams {
	return &MediaGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewMediaGetParamsWithTimeout creates a new MediaGetParams object
// with the ability to set a timeout on a request.
func NewMediaGetParamsWithTimeout(timeout time.Duration) *MediaGetParams {
	return &MediaGetParams{
		timeout: timeout,
	}
}

// NewMediaGetParamsWithContext creates a new MediaGetParams object
// with the ability to set a context for a request.
func NewMediaGetParamsWithContext(ctx context.Context) *MediaGetParams {
	return &MediaGetParams{
		Context: ctx,
	}
}

// NewMediaGetParamsWithHTTPClient creates a new MediaGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewMediaGetParamsWithHTTPClient(client *http.Client) *MediaGetParams {
	return &MediaGetParams{
		HTTPClient: client,
	}
}

/*
MediaGetParams contains all the parameters to send to the API endpoint

	for the media get operation.

	Typically these are written to a http.Request.
*/
type MediaGetParams struct {

	/* ID.

	   id of the attachment
	*/
	ID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the media get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *MediaGetParams) WithDefaults() *MediaGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the media get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *MediaGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the media get params
func (o *MediaGetParams) WithTimeout(timeout time.Duration) *MediaGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the media get params
func (o *MediaGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the media get params
func (o *MediaGetParams) WithContext(ctx context.Context) *MediaGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the media get params
func (o *MediaGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the media get params
func (o *MediaGetParams) WithHTTPClient(client *http.Client) *MediaGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the media get params
func (o *MediaGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the media get params
func (o *MediaGetParams) WithID(id string) *MediaGetParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the media get params
func (o *MediaGetParams) SetID(id string) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *MediaGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
