// Code generated by go-swagger; DO NOT EDIT.

package statuses

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewStatusPinParams creates a new StatusPinParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewStatusPinParams() *StatusPinParams {
	return &StatusPinParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewStatusPinParamsWithTimeout creates a new StatusPinParams object
// with the ability to set a timeout on a request.
func NewStatusPinParamsWithTimeout(timeout time.Duration) *StatusPinParams {
	return &StatusPinParams{
		timeout: timeout,
	}
}

// NewStatusPinParamsWithContext creates a new StatusPinParams object
// with the ability to set a context for a request.
func NewStatusPinParamsWithContext(ctx context.Context) *StatusPinParams {
	return &StatusPinParams{
		Context: ctx,
	}
}

// NewStatusPinParamsWithHTTPClient creates a new StatusPinParams object
// with the ability to set a custom HTTPClient for a request.
func NewStatusPinParamsWithHTTPClient(client *http.Client) *StatusPinParams {
	return &StatusPinParams{
		HTTPClient: client,
	}
}

/*
StatusPinParams contains all the parameters to send to the API endpoint

	for the status pin operation.

	Typically these are written to a http.Request.
*/
type StatusPinParams struct {

	/* ID.

	   Target status ID.
	*/
	ID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the status pin params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *StatusPinParams) WithDefaults() *StatusPinParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the status pin params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *StatusPinParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the status pin params
func (o *StatusPinParams) WithTimeout(timeout time.Duration) *StatusPinParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the status pin params
func (o *StatusPinParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the status pin params
func (o *StatusPinParams) WithContext(ctx context.Context) *StatusPinParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the status pin params
func (o *StatusPinParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the status pin params
func (o *StatusPinParams) WithHTTPClient(client *http.Client) *StatusPinParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the status pin params
func (o *StatusPinParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the status pin params
func (o *StatusPinParams) WithID(id string) *StatusPinParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the status pin params
func (o *StatusPinParams) SetID(id string) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *StatusPinParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
