// Code generated by go-swagger; DO NOT EDIT.

package statuses

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewStatusSourceGetParams creates a new StatusSourceGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewStatusSourceGetParams() *StatusSourceGetParams {
	return &StatusSourceGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewStatusSourceGetParamsWithTimeout creates a new StatusSourceGetParams object
// with the ability to set a timeout on a request.
func NewStatusSourceGetParamsWithTimeout(timeout time.Duration) *StatusSourceGetParams {
	return &StatusSourceGetParams{
		timeout: timeout,
	}
}

// NewStatusSourceGetParamsWithContext creates a new StatusSourceGetParams object
// with the ability to set a context for a request.
func NewStatusSourceGetParamsWithContext(ctx context.Context) *StatusSourceGetParams {
	return &StatusSourceGetParams{
		Context: ctx,
	}
}

// NewStatusSourceGetParamsWithHTTPClient creates a new StatusSourceGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewStatusSourceGetParamsWithHTTPClient(client *http.Client) *StatusSourceGetParams {
	return &StatusSourceGetParams{
		HTTPClient: client,
	}
}

/*
StatusSourceGetParams contains all the parameters to send to the API endpoint

	for the status source get operation.

	Typically these are written to a http.Request.
*/
type StatusSourceGetParams struct {

	/* ID.

	   Target status ID.
	*/
	ID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the status source get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *StatusSourceGetParams) WithDefaults() *StatusSourceGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the status source get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *StatusSourceGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the status source get params
func (o *StatusSourceGetParams) WithTimeout(timeout time.Duration) *StatusSourceGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the status source get params
func (o *StatusSourceGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the status source get params
func (o *StatusSourceGetParams) WithContext(ctx context.Context) *StatusSourceGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the status source get params
func (o *StatusSourceGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the status source get params
func (o *StatusSourceGetParams) WithHTTPClient(client *http.Client) *StatusSourceGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the status source get params
func (o *StatusSourceGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the status source get params
func (o *StatusSourceGetParams) WithID(id string) *StatusSourceGetParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the status source get params
func (o *StatusSourceGetParams) SetID(id string) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *StatusSourceGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
