// Code generated by go-swagger; DO NOT EDIT.

package statuses

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"git.coopcloud.tech/decentral1se/gtslib/models"
)

// StatusUnreblogReader is a Reader for the StatusUnreblog structure.
type StatusUnreblogReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *StatusUnreblogReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewStatusUnreblogOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 400:
		result := NewStatusUnreblogBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 401:
		result := NewStatusUnreblogUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewStatusUnreblogForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewStatusUnreblogNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 406:
		result := NewStatusUnreblogNotAcceptable()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewStatusUnreblogInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("[POST /api/v1/statuses/{id}/unreblog] statusUnreblog", response, response.Code())
	}
}

// NewStatusUnreblogOK creates a StatusUnreblogOK with default headers values
func NewStatusUnreblogOK() *StatusUnreblogOK {
	return &StatusUnreblogOK{}
}

/*
StatusUnreblogOK describes a response with status code 200, with default header values.

The unboosted status.
*/
type StatusUnreblogOK struct {
	Payload *models.Status
}

// IsSuccess returns true when this status unreblog o k response has a 2xx status code
func (o *StatusUnreblogOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this status unreblog o k response has a 3xx status code
func (o *StatusUnreblogOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this status unreblog o k response has a 4xx status code
func (o *StatusUnreblogOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this status unreblog o k response has a 5xx status code
func (o *StatusUnreblogOK) IsServerError() bool {
	return false
}

// IsCode returns true when this status unreblog o k response a status code equal to that given
func (o *StatusUnreblogOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the status unreblog o k response
func (o *StatusUnreblogOK) Code() int {
	return 200
}

func (o *StatusUnreblogOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /api/v1/statuses/{id}/unreblog][%d] statusUnreblogOK %s", 200, payload)
}

func (o *StatusUnreblogOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /api/v1/statuses/{id}/unreblog][%d] statusUnreblogOK %s", 200, payload)
}

func (o *StatusUnreblogOK) GetPayload() *models.Status {
	return o.Payload
}

func (o *StatusUnreblogOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Status)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewStatusUnreblogBadRequest creates a StatusUnreblogBadRequest with default headers values
func NewStatusUnreblogBadRequest() *StatusUnreblogBadRequest {
	return &StatusUnreblogBadRequest{}
}

/*
StatusUnreblogBadRequest describes a response with status code 400, with default header values.

bad request
*/
type StatusUnreblogBadRequest struct {
}

// IsSuccess returns true when this status unreblog bad request response has a 2xx status code
func (o *StatusUnreblogBadRequest) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this status unreblog bad request response has a 3xx status code
func (o *StatusUnreblogBadRequest) IsRedirect() bool {
	return false
}

// IsClientError returns true when this status unreblog bad request response has a 4xx status code
func (o *StatusUnreblogBadRequest) IsClientError() bool {
	return true
}

// IsServerError returns true when this status unreblog bad request response has a 5xx status code
func (o *StatusUnreblogBadRequest) IsServerError() bool {
	return false
}

// IsCode returns true when this status unreblog bad request response a status code equal to that given
func (o *StatusUnreblogBadRequest) IsCode(code int) bool {
	return code == 400
}

// Code gets the status code for the status unreblog bad request response
func (o *StatusUnreblogBadRequest) Code() int {
	return 400
}

func (o *StatusUnreblogBadRequest) Error() string {
	return fmt.Sprintf("[POST /api/v1/statuses/{id}/unreblog][%d] statusUnreblogBadRequest", 400)
}

func (o *StatusUnreblogBadRequest) String() string {
	return fmt.Sprintf("[POST /api/v1/statuses/{id}/unreblog][%d] statusUnreblogBadRequest", 400)
}

func (o *StatusUnreblogBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewStatusUnreblogUnauthorized creates a StatusUnreblogUnauthorized with default headers values
func NewStatusUnreblogUnauthorized() *StatusUnreblogUnauthorized {
	return &StatusUnreblogUnauthorized{}
}

/*
StatusUnreblogUnauthorized describes a response with status code 401, with default header values.

unauthorized
*/
type StatusUnreblogUnauthorized struct {
}

// IsSuccess returns true when this status unreblog unauthorized response has a 2xx status code
func (o *StatusUnreblogUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this status unreblog unauthorized response has a 3xx status code
func (o *StatusUnreblogUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this status unreblog unauthorized response has a 4xx status code
func (o *StatusUnreblogUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this status unreblog unauthorized response has a 5xx status code
func (o *StatusUnreblogUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this status unreblog unauthorized response a status code equal to that given
func (o *StatusUnreblogUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the status unreblog unauthorized response
func (o *StatusUnreblogUnauthorized) Code() int {
	return 401
}

func (o *StatusUnreblogUnauthorized) Error() string {
	return fmt.Sprintf("[POST /api/v1/statuses/{id}/unreblog][%d] statusUnreblogUnauthorized", 401)
}

func (o *StatusUnreblogUnauthorized) String() string {
	return fmt.Sprintf("[POST /api/v1/statuses/{id}/unreblog][%d] statusUnreblogUnauthorized", 401)
}

func (o *StatusUnreblogUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewStatusUnreblogForbidden creates a StatusUnreblogForbidden with default headers values
func NewStatusUnreblogForbidden() *StatusUnreblogForbidden {
	return &StatusUnreblogForbidden{}
}

/*
StatusUnreblogForbidden describes a response with status code 403, with default header values.

forbidden
*/
type StatusUnreblogForbidden struct {
}

// IsSuccess returns true when this status unreblog forbidden response has a 2xx status code
func (o *StatusUnreblogForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this status unreblog forbidden response has a 3xx status code
func (o *StatusUnreblogForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this status unreblog forbidden response has a 4xx status code
func (o *StatusUnreblogForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this status unreblog forbidden response has a 5xx status code
func (o *StatusUnreblogForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this status unreblog forbidden response a status code equal to that given
func (o *StatusUnreblogForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the status unreblog forbidden response
func (o *StatusUnreblogForbidden) Code() int {
	return 403
}

func (o *StatusUnreblogForbidden) Error() string {
	return fmt.Sprintf("[POST /api/v1/statuses/{id}/unreblog][%d] statusUnreblogForbidden", 403)
}

func (o *StatusUnreblogForbidden) String() string {
	return fmt.Sprintf("[POST /api/v1/statuses/{id}/unreblog][%d] statusUnreblogForbidden", 403)
}

func (o *StatusUnreblogForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewStatusUnreblogNotFound creates a StatusUnreblogNotFound with default headers values
func NewStatusUnreblogNotFound() *StatusUnreblogNotFound {
	return &StatusUnreblogNotFound{}
}

/*
StatusUnreblogNotFound describes a response with status code 404, with default header values.

not found
*/
type StatusUnreblogNotFound struct {
}

// IsSuccess returns true when this status unreblog not found response has a 2xx status code
func (o *StatusUnreblogNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this status unreblog not found response has a 3xx status code
func (o *StatusUnreblogNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this status unreblog not found response has a 4xx status code
func (o *StatusUnreblogNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this status unreblog not found response has a 5xx status code
func (o *StatusUnreblogNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this status unreblog not found response a status code equal to that given
func (o *StatusUnreblogNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the status unreblog not found response
func (o *StatusUnreblogNotFound) Code() int {
	return 404
}

func (o *StatusUnreblogNotFound) Error() string {
	return fmt.Sprintf("[POST /api/v1/statuses/{id}/unreblog][%d] statusUnreblogNotFound", 404)
}

func (o *StatusUnreblogNotFound) String() string {
	return fmt.Sprintf("[POST /api/v1/statuses/{id}/unreblog][%d] statusUnreblogNotFound", 404)
}

func (o *StatusUnreblogNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewStatusUnreblogNotAcceptable creates a StatusUnreblogNotAcceptable with default headers values
func NewStatusUnreblogNotAcceptable() *StatusUnreblogNotAcceptable {
	return &StatusUnreblogNotAcceptable{}
}

/*
StatusUnreblogNotAcceptable describes a response with status code 406, with default header values.

not acceptable
*/
type StatusUnreblogNotAcceptable struct {
}

// IsSuccess returns true when this status unreblog not acceptable response has a 2xx status code
func (o *StatusUnreblogNotAcceptable) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this status unreblog not acceptable response has a 3xx status code
func (o *StatusUnreblogNotAcceptable) IsRedirect() bool {
	return false
}

// IsClientError returns true when this status unreblog not acceptable response has a 4xx status code
func (o *StatusUnreblogNotAcceptable) IsClientError() bool {
	return true
}

// IsServerError returns true when this status unreblog not acceptable response has a 5xx status code
func (o *StatusUnreblogNotAcceptable) IsServerError() bool {
	return false
}

// IsCode returns true when this status unreblog not acceptable response a status code equal to that given
func (o *StatusUnreblogNotAcceptable) IsCode(code int) bool {
	return code == 406
}

// Code gets the status code for the status unreblog not acceptable response
func (o *StatusUnreblogNotAcceptable) Code() int {
	return 406
}

func (o *StatusUnreblogNotAcceptable) Error() string {
	return fmt.Sprintf("[POST /api/v1/statuses/{id}/unreblog][%d] statusUnreblogNotAcceptable", 406)
}

func (o *StatusUnreblogNotAcceptable) String() string {
	return fmt.Sprintf("[POST /api/v1/statuses/{id}/unreblog][%d] statusUnreblogNotAcceptable", 406)
}

func (o *StatusUnreblogNotAcceptable) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewStatusUnreblogInternalServerError creates a StatusUnreblogInternalServerError with default headers values
func NewStatusUnreblogInternalServerError() *StatusUnreblogInternalServerError {
	return &StatusUnreblogInternalServerError{}
}

/*
StatusUnreblogInternalServerError describes a response with status code 500, with default header values.

internal server error
*/
type StatusUnreblogInternalServerError struct {
}

// IsSuccess returns true when this status unreblog internal server error response has a 2xx status code
func (o *StatusUnreblogInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this status unreblog internal server error response has a 3xx status code
func (o *StatusUnreblogInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this status unreblog internal server error response has a 4xx status code
func (o *StatusUnreblogInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this status unreblog internal server error response has a 5xx status code
func (o *StatusUnreblogInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this status unreblog internal server error response a status code equal to that given
func (o *StatusUnreblogInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the status unreblog internal server error response
func (o *StatusUnreblogInternalServerError) Code() int {
	return 500
}

func (o *StatusUnreblogInternalServerError) Error() string {
	return fmt.Sprintf("[POST /api/v1/statuses/{id}/unreblog][%d] statusUnreblogInternalServerError", 500)
}

func (o *StatusUnreblogInternalServerError) String() string {
	return fmt.Sprintf("[POST /api/v1/statuses/{id}/unreblog][%d] statusUnreblogInternalServerError", 500)
}

func (o *StatusUnreblogInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}
