// Code generated by go-swagger; DO NOT EDIT.

package timelines

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewPublicTimelineParams creates a new PublicTimelineParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPublicTimelineParams() *PublicTimelineParams {
	return &PublicTimelineParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPublicTimelineParamsWithTimeout creates a new PublicTimelineParams object
// with the ability to set a timeout on a request.
func NewPublicTimelineParamsWithTimeout(timeout time.Duration) *PublicTimelineParams {
	return &PublicTimelineParams{
		timeout: timeout,
	}
}

// NewPublicTimelineParamsWithContext creates a new PublicTimelineParams object
// with the ability to set a context for a request.
func NewPublicTimelineParamsWithContext(ctx context.Context) *PublicTimelineParams {
	return &PublicTimelineParams{
		Context: ctx,
	}
}

// NewPublicTimelineParamsWithHTTPClient creates a new PublicTimelineParams object
// with the ability to set a custom HTTPClient for a request.
func NewPublicTimelineParamsWithHTTPClient(client *http.Client) *PublicTimelineParams {
	return &PublicTimelineParams{
		HTTPClient: client,
	}
}

/*
PublicTimelineParams contains all the parameters to send to the API endpoint

	for the public timeline operation.

	Typically these are written to a http.Request.
*/
type PublicTimelineParams struct {

	/* Limit.

	   Number of statuses to return.

	   Default: 20
	*/
	Limit *int64

	/* Local.

	   Show only statuses posted by local accounts.
	*/
	Local *bool

	/* MaxID.

	   Return only statuses *OLDER* than the given max status ID. The status with the specified ID will not be included in the response.
	*/
	MaxID *string

	/* MinID.

	   Return only statuses *NEWER* than the given since status ID. The status with the specified ID will not be included in the response.
	*/
	MinID *string

	/* SinceID.

	   Return only statuses *NEWER* than the given since status ID. The status with the specified ID will not be included in the response.
	*/
	SinceID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the public timeline params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PublicTimelineParams) WithDefaults() *PublicTimelineParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the public timeline params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PublicTimelineParams) SetDefaults() {
	var (
		limitDefault = int64(20)

		localDefault = bool(false)
	)

	val := PublicTimelineParams{
		Limit: &limitDefault,
		Local: &localDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the public timeline params
func (o *PublicTimelineParams) WithTimeout(timeout time.Duration) *PublicTimelineParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the public timeline params
func (o *PublicTimelineParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the public timeline params
func (o *PublicTimelineParams) WithContext(ctx context.Context) *PublicTimelineParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the public timeline params
func (o *PublicTimelineParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the public timeline params
func (o *PublicTimelineParams) WithHTTPClient(client *http.Client) *PublicTimelineParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the public timeline params
func (o *PublicTimelineParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithLimit adds the limit to the public timeline params
func (o *PublicTimelineParams) WithLimit(limit *int64) *PublicTimelineParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the public timeline params
func (o *PublicTimelineParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithLocal adds the local to the public timeline params
func (o *PublicTimelineParams) WithLocal(local *bool) *PublicTimelineParams {
	o.SetLocal(local)
	return o
}

// SetLocal adds the local to the public timeline params
func (o *PublicTimelineParams) SetLocal(local *bool) {
	o.Local = local
}

// WithMaxID adds the maxID to the public timeline params
func (o *PublicTimelineParams) WithMaxID(maxID *string) *PublicTimelineParams {
	o.SetMaxID(maxID)
	return o
}

// SetMaxID adds the maxId to the public timeline params
func (o *PublicTimelineParams) SetMaxID(maxID *string) {
	o.MaxID = maxID
}

// WithMinID adds the minID to the public timeline params
func (o *PublicTimelineParams) WithMinID(minID *string) *PublicTimelineParams {
	o.SetMinID(minID)
	return o
}

// SetMinID adds the minId to the public timeline params
func (o *PublicTimelineParams) SetMinID(minID *string) {
	o.MinID = minID
}

// WithSinceID adds the sinceID to the public timeline params
func (o *PublicTimelineParams) WithSinceID(sinceID *string) *PublicTimelineParams {
	o.SetSinceID(sinceID)
	return o
}

// SetSinceID adds the sinceId to the public timeline params
func (o *PublicTimelineParams) SetSinceID(sinceID *string) {
	o.SinceID = sinceID
}

// WriteToRequest writes these params to a swagger request
func (o *PublicTimelineParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Local != nil {

		// query param local
		var qrLocal bool

		if o.Local != nil {
			qrLocal = *o.Local
		}
		qLocal := swag.FormatBool(qrLocal)
		if qLocal != "" {

			if err := r.SetQueryParam("local", qLocal); err != nil {
				return err
			}
		}
	}

	if o.MaxID != nil {

		// query param max_id
		var qrMaxID string

		if o.MaxID != nil {
			qrMaxID = *o.MaxID
		}
		qMaxID := qrMaxID
		if qMaxID != "" {

			if err := r.SetQueryParam("max_id", qMaxID); err != nil {
				return err
			}
		}
	}

	if o.MinID != nil {

		// query param min_id
		var qrMinID string

		if o.MinID != nil {
			qrMinID = *o.MinID
		}
		qMinID := qrMinID
		if qMinID != "" {

			if err := r.SetQueryParam("min_id", qMinID); err != nil {
				return err
			}
		}
	}

	if o.SinceID != nil {

		// query param since_id
		var qrSinceID string

		if o.SinceID != nil {
			qrSinceID = *o.SinceID
		}
		qSinceID := qrSinceID
		if qSinceID != "" {

			if err := r.SetQueryParam("since_id", qSinceID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
